class EmptyQueueException extends Exception {}
class IndexOutOfBoundsException extends Exception {}

public class FIFOQueue2 {
    private int capacity = 2;
    private Object array[] = new Object[capacity]; 
    private int num = 0; 

    private void makeSpace() {
        capacity *= 2;
        Object temp[] = new Object[capacity];
        for (int i=0; i<num; i++) 
            temp[i] = array[i];

        array = temp;
    }

    /* ---------------------------------------------- */
    /*            PUBLIC INTERFACE METHODS            */
    /* ---------------------------------------------- */

    FIFOQueue2() {}
    public void push(Object elem) {
        if (num==capacity) makeSpace();
        array[num++] = elem;
    }
    public Object pop() throws EmptyQueueException {
        if (num==0) throw new EmptyQueueException();
        Object ret = array[0];
        for (int i=1; i<num; i++) array[i-1] = array[i];
        num--;
        return ret;
    }
    public int getNum() { return num; }
    
    public int getCapacity() { return capacity; }

    public Object getElem(int i) throws IndexOutOfBoundsException {
        if (i<0 || i>=num) throw new IndexOutOfBoundsException();
        return array[i];
    }

    /* ---------------------------------------------- */

    public static void main(String args[]) {
        FIFOQueue2 myq = new FIFOQueue2();

        for (int i=0; i<5; i++) 
            myq.push(new MyClass());

        try {
            System.out.println("Index at 7" + myq.getElem(7));
        } catch (IndexOutOfBoundsException e) {
            System.out.println("Exception: getElem() index out of bound");
        }
        
        System.out.println("Capacity: " + myq.getCapacity());
        System.out.println("Num: " + myq.getNum());
        
        try {
            while (myq.getNum() > 0) 
                System.out.println("Elem: " + ((MyClass)myq.pop()).get());
            myq.pop();
        } catch (EmptyQueueException e) {
            System.out.println("Exception: pop() on an empty queue");
        }
    }
}
