class EmptyQueueException extends Exception {}
class NoNextElementException extends Exception {}
class IndexOutOfBoundsException extends Exception {}

class QueueList<T> {
    class Node {
        T elem;
        Node next = null;
        Node prev = null;
        Node(T elem) { this.elem = elem; }
    }
    private Node head = null, tail = null;
    private Node curr = null;
    public QueueList() {}

    public void push(T elem) {
        Node n = new Node(elem);
        n.prev = tail;

        if (tail != null) tail.next = n;
        else head = n;
        tail = n;
    }

    public T pop() throws EmptyQueueException {
        if (head == null) throw new EmptyQueueException();
        Node n = head;
        head = n.next;
        if (head != null) head.prev = null;
        else tail = null;
        return n.elem;
    }

    public void start() { curr = head; }

    public boolean hasNext() { 
        if (curr == null) return false;
        else return true;
    }

    public T getNext() throws NoNextElementException {
        if (curr == null) throw new NoNextElementException();
        T ret = curr.elem;
        curr = curr.next;
        return ret;
    }

    public static void main(String args[]) {
        QueueList<MyClass> myq = new QueueList<MyClass>();

        myq.push(new MyClass());
        myq.push(new MyClass());
        myq.push(new MyClass());
        myq.push(new MyClass());

        myq.start();
        try {
            while (myq.hasNext()) 
                System.out.println(myq.getNext().get());
        } catch(NoNextElementException e) {
            System.out.println("empty!");
        }
    }


}
