import java.util.*;

public class QueueListIt<E> implements Iterable<E> {
    private class Node {
        E elem;
        Node next = null;
        Node prev = null;
        Node(E elem) { this.elem = elem; }
    }
    private Node head = null, tail = null;

    private class QLIterator implements Iterator<E> {
        private Node curr = null;
        private Node prev = null;

        QLIterator() { curr = head; }

        public boolean hasNext() { 
            if (curr == null) return false;
            else return true;
        }
        
        public E next() {
            if (curr == null) return null;
            E elem = curr.elem;
            prev = curr;
            curr = curr.next;
            return elem;
        }

        public void remove() {
            if (prev == null) return;
            // remove element
            Node p = prev.prev;
            Node f = prev.next;
            if (p == null) head = f;
            else p.next = f;
            if (f == null) tail = p;
            else f.prev = p;
            prev = null;
        }
    }

    public QueueListIt() {}

    public void push(E elem) {
        Node n = new Node(elem);
        n.prev = tail;

        if (tail != null) tail.next = n;
        else head = n;
        tail = n;
    }

    public E pop() throws EmptyQueueException {
        if (head == null) throw new EmptyQueueException();
        Node n = head;
        head = n.next;
        if (head != null) head.prev = null;
        else tail = null;
        return n.elem;
    }

    public Iterator<E> iterator() { return new QLIterator(); }

    public static void main(String args[]) {
        QueueListIt<MyClass> myq = new QueueListIt<MyClass>();

        for (int i=0; i<6; i++) 
            myq.push(new MyClass());

        System.out.println("Elements:");
        for (MyClass c : myq) 
            System.out.println(c);

        Iterator<MyClass> i = myq.iterator();
        while (i.hasNext()) 
            if (i.next().get() % 2 == 0) 
                i.remove();

        System.out.println("Elements after filter:");
        for (MyClass c : myq) 
            System.out.println(c);
    }
}
